diff --git a/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
similarity index 93%
rename from src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
rename to game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
index 355de9d45..2bb384149 100644
--- a/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
@@ -4,6 +4,8 @@ import java.util.HashSet;
 import java.util.List;
 import java.util.Set;
 
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import org.lwjgl.opengl.GL11;
 
@@ -80,14 +82,14 @@ public class ChunkRendererLegacy extends ChunkRenderer {
                             	tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
                             }
                         }
-                        if(renderPass == 0 && Block.isEntityTile[blockId]) {
+                        if(renderPass == 0 && Blocks.isEntityTile[blockId]) {
                             final TileEntity tileentity = chunkcache.getBlockEntity(x, y, z);
                             if(BlockEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
                                 renderableBlockEntities.add(tileentity);
                             }
                         }
-                        final Block block = Block.blocksList[blockId];
-                        final int blockRenderPass = block.getRenderLayer();
+                        final BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[blockId]);
+                        final int blockRenderPass = model.renderLayer();
                         if(blockRenderPass != renderPass) {
                             needsMoreRenderPasses = true;
                         }
@@ -97,7 +99,7 @@ public class ChunkRendererLegacy extends ChunkRenderer {
                         		tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 0));
                         	}
 
-    						hasRenderedBlock |= renderBlock(tessellator, renderblocks, block, x, y, z);
+    						hasRenderedBlock |= renderBlock(tessellator, renderblocks, model, x, y, z);
                         }
                     }
                 }
diff --git a/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
similarity index 93%
rename from src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
rename to game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
index a096785f2..50ed053cb 100644
--- a/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
@@ -8,11 +8,12 @@ import net.minecraft.client.render.BlockEntityRenderDispatcher;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.client.render.terrain.VertexBuffer.Entry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.tessellator.TessellatorStandard;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
@@ -91,21 +92,21 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
 							tessellator.setColorRGBA(255, 255, 255, 255);
 							tessellator.setTextureUV(0.0, 0.0);
 						}
-						if(renderPass == 0 && Block.isEntityTile[blockId]) {
+						if(renderPass == 0 && Blocks.isEntityTile[blockId]) {
 							final TileEntity tileentity = chunkCache.getBlockEntity(x, y, z);
 							if(BlockEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
 								renderableBlockEntities.add(tileentity);
 							}
 						}
-						final Block block = Block.blocksList[blockId];
-						final int blockRenderPass = block.getRenderLayer();
+						final BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[blockId]);
+						final int blockRenderPass = model.renderLayer();
 						
 						if(blockRenderPass != renderPass) {
 							needsMoreRenderPasses = true;
 							continue;
 						}
 						
-						hasRenderedBlock |= renderBlock(tessellator, renderBlocks, block, x, y, z);
+						hasRenderedBlock |= renderBlock(tessellator, renderBlocks, model, x, y, z);
 					}
 				}
 			}
diff --git a/src/main/java/net/minecraft/core/util/helper/ScreenShot.java b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
similarity index 98%
rename from src/main/java/net/minecraft/core/util/helper/ScreenShot.java
rename to game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
index 0227155db..6dbaa8add 100644
--- a/src/main/java/net/minecraft/core/util/helper/ScreenShot.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
@@ -1,4 +1,4 @@
-package net.minecraft.core.util.helper;
+package net.minecraft.client.util.helper;
 
 import java.awt.image.BufferedImage;
 import java.io.File;
diff --git a/src/main/java/net/minecraft/client/world/WorldClientMP.java b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
similarity index 98%
rename from src/main/java/net/minecraft/client/world/WorldClientMP.java
rename to game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
index 98c03d6e3..74353919e 100644
--- a/src/main/java/net/minecraft/client/world/WorldClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
@@ -5,7 +5,7 @@ import net.minecraft.client.world.chunk.provider.ChunkProviderClient;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.net.packet.DisconnectPacket;
+import net.minecraft.core.net.packet.PacketDisconnect;
 import net.minecraft.core.util.collection.IntHashMap;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
@@ -260,7 +260,7 @@ public class WorldClientMP extends WorldClient {
     @Override
 	public void sendQuittingDisconnectingPacket()
     {
-        sendQueue.sendFinalPacket(new DisconnectPacket("Quitting"));
+        sendQueue.sendFinalPacket(new PacketDisconnect("Quitting"));
     }
 
     @Override
diff --git a/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java b/game/client/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
similarity index 89%
rename from src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
rename to game/client/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
index 3eaf71ea3..2793bc73a 100644
--- a/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
+++ b/game/client/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
@@ -1,6 +1,7 @@
 package org.useless.seedviewer.bta;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.MaterialColor;
 import org.jetbrains.annotations.NotNull;
@@ -21,7 +22,7 @@ public class BTAComplexChunk implements Chunk {
 
     @Override
     public int getBlockColor(ChunkPos3D pos) {
-        Block b = Block.getBlock(chunk.getBlockID(pos.x, pos.y, pos.z));
+        Block b = Blocks.getBlock(chunk.getBlockID(pos.x, pos.y, pos.z));
         if (b == null) return 0;
         int meta = chunk.getBlockMetadata(pos.x, pos.y, pos.z);
         return MaterialColor.getColorFromIndex(MaterialColor.getColorIndexFromBlock(b, meta)) | 0xFF_00_00_00;
@@ -39,7 +40,7 @@ public class BTAComplexChunk implements Chunk {
         while (true) {
             int y = start - depth;
             if (y < 0) break;
-            Block b = Block.getBlock(chunk.getBlockID(pos.x, y, pos.z));
+            Block b = Blocks.getBlock(chunk.getBlockID(pos.x, y, pos.z));
             if (b == null) break;
             if (b.blockMaterial != Material.water) break;
             depth++;
diff --git a/game/core/.gitignore b/game/core/.gitignore
new file mode 100644
index 000000000..378eac25d
--- /dev/null
+++ b/game/core/.gitignore
@@ -0,0 +1 @@
+build
diff --git a/game/core/build.gradle.kts b/game/core/build.gradle.kts
new file mode 100644
index 000000000..c07796b5a
--- /dev/null
+++ b/game/core/build.gradle.kts
@@ -0,0 +1,79 @@
+import java.util.*
+
+plugins {
+    id("java")
+}
+
+group = providers.gradleProperty("bta.group").get()
+version = providers.gradleProperty("bta.version").get()
+val texturePackFormat = providers.gradleProperty("bta.texturePackFormat").get()
+val buildChannel = providers.gradleProperty("bta.buildChannel").get()
+
+run {
+    val file = File("version.txt")
+    if (file.exists()) {
+        val ver = file.readText().trim()
+        version = ver
+    }
+}
+
+repositories {
+    mavenCentral()
+    maven("https://libraries.minecraft.net/")
+}
+
+dependencies {
+    // <core dependencies>
+    implementation(libs.jetbrains.annotations)
+    implementation(libs.gson)
+    implementation(libs.brigadier)
+    implementation(libs.bundles.log4j)
+    // </core dependencies>
+}
+
+java {
+    sourceCompatibility = JavaVersion.VERSION_1_8
+    targetCompatibility = JavaVersion.VERSION_1_8
+}
+
+//region Tasks
+val versionGenerator by tasks.registering {
+    group = "bta.generator"
+    val versionDir = project.layout.buildDirectory.dir("generated/sources/version/java")
+    val outputFile = versionDir.get().file("net/minecraft/core/Version.java").asFile
+    outputs.dir(versionDir)
+
+    doLast {
+        outputFile.parentFile.mkdirs()
+        outputFile.writeText(
+                """
+                    package net.minecraft.core;
+                    
+                    public final class Version {
+                        public static final String VERSION = "$version";
+                        public static final long BUILD_TIME = ${Date().time}L;
+                        public static final int TEXTURE_PACK_FORMAT = $texturePackFormat;
+                        public static final BuildChannel BUILD_CHANNEL = $buildChannel;
+                    }
+                """.trimIndent()
+        )
+    }
+}
+
+tasks.withType(JavaCompile::class.java) {
+    options.isIncremental = false
+    options.encoding = "UTF-8"
+    if (JavaVersion.current() != JavaVersion.VERSION_1_8) {
+        options.compilerArgs.add("--release")
+        options.compilerArgs.add("8")
+    }
+}
+//endregion
+
+sourceSets {
+    main {
+        java {
+            srcDir(versionGenerator)
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/Global.java b/game/core/src/main/java/net/minecraft/core/Global.java
similarity index 94%
rename from src/main/java/net/minecraft/core/Global.java
rename to game/core/src/main/java/net/minecraft/core/Global.java
index c229ed68f..b443ee094 100644
--- a/src/main/java/net/minecraft/core/Global.java
+++ b/game/core/src/main/java/net/minecraft/core/Global.java
@@ -5,13 +5,13 @@ public class Global
 	public static final int TICKS_PER_SECOND = 20;
 	public static final int DAY_LENGTH_TICKS = 24000;
 	public static final String VERSION = Version.BUILD_CHANNEL.modifyVersionString(Version.VERSION);
-	public static final String BUILD_TIME = Version.BUILD_TIME;
+	public static final long BUILD_TIME = Version.BUILD_TIME;
 	public static final BuildChannel BUILD_CHANNEL = Version.BUILD_CHANNEL;
 	public static final int CURRENT_SAVE_VERSION = 19134;
 	public static final int CURRENT_CHUNK_VERSION = 2;
 	public static boolean isServer = false;
 	public static final boolean DISABLE_OLD_WORLDS = false;
-	public static final int TEXTURE_PACK_FORMAT = Version.TEXTURE_PACK_VERSION;
+	public static final int TEXTURE_PACK_FORMAT = Version.TEXTURE_PACK_FORMAT;
 	public static final boolean NET_DEBUG = false;
 	public static final boolean ASSERTIONS_ENABLED;
 	static {
